#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "parseMsg.y"
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cstdarg>
#include <unistd.h>
extern "C" {

#define MAX_ERRORS 1

int     AUDinit(const char *);
float    AUDupdate(int, char *, int, float *);
float    AUDupdateSimple(char *, int, float *);
float    AUDupdateFloats(int, char *, int, ...);
float    AUDupdateSimpleFloats(char *, int, ...);
void    AUDterminate(int);
void	AUDqueue(int, float *, float);
void	AUDflushQueue(int, char*, int);
void	SetReplyTimeout(float);

int yyparse(void);
int yylex(void);
extern "C" void yyerror(const char *msg);

}

#include "symtab.h"

#define	fdMax	100		/* Max times a single app can call init*/
#include "actorMsg.h"
#include "cliMsg.h"

int findActorName(int fdT, char *aString);
int findNoteName(char *aString);
void AppendArg(char* sz);
void AppendFloat(float z);

char			curFileName[180] = {0};
char			prevFileName[180] = {0};
extern FILE		*yyin;
int numErrors;
static SymtabActor symtabActor[fdMax];
static SymtabNote symtabNote[fdMax];
static int		serverHandles[fdMax];
static char		theArgs[1500];
static float	vhActor;
static char vszhnote[200];
static float vhNote;
static int		argCount;
static int		fd = 0;		/* like a "file descriptor"*/
char*			typeptr;
extern int		currentServerHandle;	/* in cliMsg.c*/
static int		vfPaused;
static int 		vfEnableWarnNoMG = 1;
int fFiltered = 0; /* not static*/
char vszFilterCommand[500] = {0};
int vfAbsorbText = 0;


typedef struct
{
	float time;
	int	  size;
	float *farray;
}	audqdata;
#define	qdMax	32	/*	Max times a client can call AUDqueue*/
					/*	between calls to AUDflush*/
static audqdata Qdata[qdMax];
static int 		QdataCount = 0;

extern "C" int yywrap() { return 1; }

extern "C" void AUDEnableNoMessageGroupWarning(int f)
	{ vfEnableWarnNoMG = f; }

#line 79 "parseMsg.y"
typedef union	{
	char			string[512];
	int		actorMessage;	/*xx30 only for vss-builtin msgs*/
} YYSTYPE;
#line 92 "y.tab.c"
#define tOPEN_BRACE 257
#define tCLOSE_BRACE 258
#define tSTAR 259
#define tDOLLAR 260
#define tQMARK 261
#define tEQUAL 262
#define tOPEN_SQB 263
#define tCLOSE_SQB 264
#define tSEMICOLON 265
#define tTO 266
#define tERROR 267
#define tSLEEP 268
#define tAT 269
#define tTIMEOUT 270
#define tPRINT 271
#define tESCAPEDDOUBLEQUOTE 272
#define tSTRING 273
#define tNUMBER 274
#define tPRAGMA 275
#define tCREATE_MESSAGE 276
#define tDELETE_MESSAGE 277
#define tBEGIN_NOTE_MESSAGE 278
#define tBEGIN_PAUSED_NOTE_MESSAGE 279
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    7,    8,    8,    9,    8,    8,   11,
    8,    8,    8,    8,    6,    6,   12,    4,   10,   10,
   13,   13,   13,   13,   13,   13,   13,   14,   19,   17,
   17,    2,    3,   20,   21,   16,   16,   22,   22,   23,
   24,   15,    5,    1,    1,    1,    1,    1,    1,   18,
   18,   18,   18,
};
short yylen[] = {                                         2,
    1,    1,    2,    2,    4,    1,    0,    4,    2,    0,
    3,    1,    1,    1,    1,    1,    0,    4,    0,    2,
    1,    1,    1,    1,    1,    1,    1,    2,    0,    4,
    2,    1,    1,    1,    1,    1,    0,    1,    2,    1,
    1,    1,    1,    1,    2,    2,    3,    2,    1,    1,
    2,    5,    5,
};
short yydefred[] = {                                      0,
   12,   13,   14,    0,    1,    0,   15,   16,    0,    6,
    0,    2,    0,    0,   19,    9,    3,   17,    4,    0,
    0,    0,   19,    5,    8,    0,   40,   42,   43,   32,
   22,   23,   24,   25,   21,   33,   44,   49,   20,   26,
   27,    0,    0,    0,   38,    0,   48,    0,   28,   45,
   34,   46,    0,   39,   31,    0,   47,   50,    0,    0,
    0,   30,   51,    0,   41,    0,    0,   35,   52,   53,
};
short yydgoto[] = {                                       9,
   35,   36,   37,   10,   38,   11,   12,   13,   21,   22,
   15,   23,   39,   40,   41,   42,   49,   59,   56,   43,
   70,   44,   45,   66,
};
short yysindex[] = {                                   -189,
    0,    0,    0, -250,    0, -259,    0,    0, -177,    0,
 -239,    0, -227, -231,    0,    0,    0,    0,    0, -209,
 -248, -226,    0,    0,    0, -205,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -197, -206, -253,    0, -226,    0, -190,    0,    0,
    0,    0, -206,    0,    0, -202,    0,    0, -215, -206,
 -253,    0,    0, -191,    0, -183, -251,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0, -237,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -217,    0,    0,    0,    0,    0,    0,
    0, -252,    0,    0,    0, -194,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -180,    0, -236,    0, -196,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -204,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
  -52,    0,  -43,   64,    0,    0,   78,    0,    0,   69,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -41,
    0,  -51,  -42,    0,
};
#define YYTABLESIZE 102
short yytable[] = {                                      50,
   52,   54,   53,   58,   61,   51,   63,   61,   68,   57,
   37,   14,   11,   16,   60,   27,   64,   52,   54,   53,
   30,   10,   30,   69,   67,   10,   37,   10,   18,    7,
    8,   10,   26,   18,   10,   10,   10,   19,   10,   10,
   10,   10,   27,   26,   20,   28,   29,   30,   62,   31,
   32,   33,   34,   27,   45,   47,   26,   29,   30,   45,
    7,    7,   29,   24,   45,   48,   27,   30,   45,   45,
   29,   30,   29,   55,   65,   51,   29,   29,    1,   34,
    2,    3,   36,    4,   25,    5,   17,    6,    7,    8,
    1,   46,    2,    3,    0,    4,    0,    0,    0,    6,
    7,    8,
};
short yycheck[] = {                                      43,
   44,   44,   44,   56,   56,  259,   59,   59,  260,   53,
  263,  262,  265,  273,   56,  269,   60,   61,   61,   61,
  274,  259,  274,   67,   66,  263,  263,  265,  265,  278,
  279,  269,  259,  273,  272,  273,  274,  265,  276,  277,
  278,  279,  269,  259,  276,  272,  273,  274,  264,  276,
  277,  278,  279,  269,  259,  261,  259,  273,  274,  264,
  278,  279,  259,  273,  269,  263,  269,  274,  273,  274,
  273,  274,  269,  264,  266,  259,  273,  274,  268,  274,
  270,  271,  263,  273,   21,  275,    9,  277,  278,  279,
  268,   23,  270,  271,   -1,  273,   -1,   -1,   -1,  277,
  278,  279,
};
#define YYFINAL 9
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 279
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"tOPEN_BRACE","tCLOSE_BRACE",
"tSTAR","tDOLLAR","tQMARK","tEQUAL","tOPEN_SQB","tCLOSE_SQB","tSEMICOLON","tTO",
"tERROR","tSLEEP","tAT","tTIMEOUT","tPRINT","tESCAPEDDOUBLEQUOTE","tSTRING",
"tNUMBER","tPRAGMA","tCREATE_MESSAGE","tDELETE_MESSAGE","tBEGIN_NOTE_MESSAGE",
"tBEGIN_PAUSED_NOTE_MESSAGE",
};
char *yyrule[] = {
"$accept : Messages",
"Messages : tPRAGMA",
"Messages : MessageSemicolon",
"Messages : Messages MessageSemicolon",
"MessageSemicolon : Message tSEMICOLON",
"Message : tSTRING tEQUAL tCREATE_MESSAGE tSTRING",
"Message : BeginNoteBody",
"$$1 :",
"Message : tSTRING tEQUAL $$1 BeginNoteBody",
"Message : tDELETE_MESSAGE tSTRING",
"$$2 :",
"Message : tSTRING $$2 Args",
"Message : tSLEEP",
"Message : tTIMEOUT",
"Message : tPRINT",
"aBeginNoteMessage : tBEGIN_NOTE_MESSAGE",
"aBeginNoteMessage : tBEGIN_PAUSED_NOTE_MESSAGE",
"$$3 :",
"BeginNoteBody : aBeginNoteMessage tSTRING $$3 Args",
"Args :",
"Args : Args Arg",
"Arg : Float",
"Arg : tCREATE_MESSAGE",
"Arg : tDELETE_MESSAGE",
"Arg : tBEGIN_NOTE_MESSAGE",
"Arg : tBEGIN_PAUSED_NOTE_MESSAGE",
"Arg : Farray",
"Arg : DoubleQuote",
"Farray : AtsMaybe RawArray",
"$$4 :",
"RawArray : tOPEN_SQB $$4 Floats tCLOSE_SQB",
"RawArray : tOPEN_SQB tCLOSE_SQB",
"NormalFloat : tNUMBER",
"NormalFloatArg : NormalFloat",
"Star : tSTAR",
"Dollar : tDOLLAR",
"AtsMaybe : Ats",
"AtsMaybe :",
"Ats : At",
"Ats : Ats At",
"At : tAT",
"To : tTO",
"DoubleQuote : tESCAPEDDOUBLEQUOTE",
"Handle : tSTRING",
"Float : NormalFloatArg",
"Float : Star NormalFloatArg",
"Float : Ats NormalFloatArg",
"Float : Ats Star NormalFloatArg",
"Float : tSTAR tQMARK",
"Float : Handle",
"Floats : Float",
"Floats : Floats Float",
"Floats : Star NormalFloatArg To Star NormalFloatArg",
"Floats : Star NormalFloatArg To Star Dollar",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 325 "parseMsg.y"

/**********************************************/

void AppendArg(char* sz)
{
	strcat(theArgs, sz);
}

void AppendFloat(float z)
{
	char sz[20];
	sprintf(sz, "%f", z);
	AppendArg(sz);
}

/**********************************************/

extern int yylineno;
int hAudSimple = -1;

extern "C" int AUDinit(const char *fileName)
{
	if (currentServerHandle < 1)
		{
		fprintf(stderr, "vss client error: no connection to sound server!\n");
		return -1;
		}

	if (fd >= fdMax)
		{
		fprintf(stderr, "vss client error:  can't AUDinit() more than %d times\nwithout AUDterminate()'ing old ones first.\nFile \"%s\" not read.\n", fdMax, fileName);
		return -1;
		}

	*vszFilterCommand = '\0';
	fFiltered = 0;
	vfAbsorbText = 0;

	yyin = fopen(fileName, "r");
	if (!yyin)
		{
		fprintf(stderr, "vss client error: can't read file \"%s\"\n", fileName);
		return -1;
		}
	if (!strcmp(fileName, prevFileName))
		{
		fprintf(stderr, "vss client warning: loading .aud file \"%s\" twice in a row.\n", fileName);
		}

LAgain:
	strcpy(curFileName, fileName);
	strcpy(prevFileName, fileName);
	symtabActor[fd].Reset();
	symtabNote[fd].Reset();
	numErrors = 0;
	yylineno = 0;

	while (!feof(yyin) && numErrors <= MAX_ERRORS)
		{
		argCount = 0;
		int fOK = yyparse() == 0;
		int fGonnaFilter = !fFiltered && *vszFilterCommand;
		if (!fOK && !fGonnaFilter)
			{
			if (yylineno <= 0)
				fprintf(stderr, "vss client warning: File \"%s\" may be empty.\n",
					fileName);
			else
				fprintf(stderr, "vss client error: Syntax error in file \"%s\", line %d\n",
					fileName, yylineno);
			}
		if (fGonnaFilter)
			{
			fFiltered = 1;
			fclose(yyin);
			// munch fileName into a temp file
			char szCmd[1500];
			unlink("/tmp/_-vss-_FiLtEr_--_");
			sprintf(szCmd, "cat %s | %s > /tmp/_-vss-_FiLtEr_--_",
				fileName, vszFilterCommand);
			/*printf("\n\n[[[%s]]]\n\n", szCmd);*/
			system(szCmd);
			/*system("cp /tmp/_-vss-_FiLtEr_--_ /tmp/asdf");*/
			yyin = fopen("/tmp/_-vss-_FiLtEr_--_", "r");
			vfAbsorbText = 0;
			goto LAgain; // real programmers aren't afraid to use goto's
			}
		fFiltered = 1; // pragma filter has to be first in the .aud file.
		}
	fclose(yyin);
	unlink("/tmp/_-vss-_FiLtEr_--_");
	if (numErrors > MAX_ERRORS)
		{
		fprintf(stderr, "vss client error: Too many errors -- aborting AUDinit\n");
		return -1;
		}

	// If the aud file was loaded successfully, remember the current server handle.
	serverHandles[fd] = currentServerHandle;

	hAudSimple = fd;
	return fd++;	 	// return the row # of actors allocated
}

/**********************************************/

static int vfHush = 0;
extern "C" void AUDterminateImplicit(void)
{
	if (hAudSimple >= 0)
		{
		vfHush = 1;
		AUDterminate(hAudSimple);
		vfHush = 0;
		}
}

extern "C" void AUDterminate(int fdT)
{
	float h;
	if (fdT < 0)
		{
		if (!vfHush)
			fprintf(stderr, "vss client error: invalid handle to .aud file.  Possible error in .aud file.\n");
		return;
		}
	if (serverHandles[fdT] <= 0)
		{
		if (!vfHush)
			fprintf(stderr, "vss client error: bogus AUDterminate().\n");
		return;
		}

	int sendEm = SelectSoundServer(serverHandles[fdT]);

	if (fdT < 0 || fdT >= fdMax)
		{
		if (!vfHush)
			fprintf(stderr, "vss client error: AUDterminate called with bogus value %d\n", fdT);
		return;
		}
	SymtabActor* pA = &symtabActor[fdT];

/*
	First de-activate all the actors, then delete them. That way the order
	of deletion doesn't matter because there will be no important dependencies
	between the various actors. In particular, inactive actors won't generate
	audEvents.
*/
	if (sendEm)
		{
		char szT[500];
		for (h = pA->HFirst(); h != -1.; h = pA->HNext())
			{
			sprintf(szT, "Active %f 0", h);
			actorMessage(szT);
			}
		for (h = pA->HFirst(); h != -1.; h = pA->HNext())
			{
			sprintf(szT, "Delete %f", h);
			actorMessage(szT);
			}
		}
	pA->Reset();

	// set the server handle for this call to 0
	serverHandles[fdT] = 0;

	// reuse array, if AUDterminates match up with AUDinits.
	if (fdT == fd-1)
		fd--;

	// Suppress spurious warning.
	*prevFileName = '\0';
}

//===========================================================================
//		AUDreset
//
//	Terminate all of this client's server connections.
//
extern "C" void AUDreset(void)
{
	for (int fdT = 0; fdT < fdMax; fdT++)
		if (serverHandles[fdT] > 0) AUDterminate(fdT);
	fd = 0;
	QdataCount = 0;
}

extern "C"
float AUDupdateSimple(char *szActor, int numFloats, float *floatArray)
{
	if (hAudSimple >= 0)
		return AUDupdate(hAudSimple, szActor, numFloats, floatArray);

	fprintf(stderr, "vss client error: AUDupdateSimple() without preceding AUDinit().\n");
	return hNil;
}

float AUDupdateSimpleFloats(char* szActor, int numFloats, ...)
{
	if (hAudSimple < 0)
		{
		fprintf(stderr, "vss client error: AUDupdateSimpleFloats() without preceding AUDinit().\n");
		return hNil;
		}

	// Build an array and then pass it to the conventional AUDupdate().

	const int numFloatsMax = 1000;
	static float rgz[numFloatsMax]; // not re-entrant, but that's OK.
	if (numFloats > numFloatsMax)
		{
		fprintf(stderr, "VSS client warning: AUDupdateFloats() truncated list of %d floats to %d.\n",
			numFloats, numFloatsMax);
		numFloats = numFloatsMax;
		}
	va_list _;
	va_start(_, numFloats);
	for (int i=0; i<numFloats; i++)
		rgz[i] = (float)va_arg(_, double);
	va_end(_);
	return AUDupdate(hAudSimple, szActor, numFloats, rgz);
}

float AUDupdateFloats(int fdT, char* szActor, int numFloats, ...)
{
	// Build an array and then pass it to the conventional AUDupdate().

	const int numFloatsMax = 1000;
	static float rgz[numFloatsMax]; // not re-entrant, but that's OK.
	if (numFloats > numFloatsMax)
		{
		fprintf(stderr, "VSS client warning: AUDupdateFloats() truncated list of %d floats to %d.\n",
			numFloats, numFloatsMax);
		numFloats = numFloatsMax;
		}
	va_list _;
	va_start(_, numFloats);
	for (int i=0; i<numFloats; i++)
		rgz[i] = (float)va_arg(_, double);
	va_end(_);
	return AUDupdate(fdT, szActor, numFloats, rgz);
}

//===========================================================================
//		AUDupdate
//
//	Send a data array to the message group called szActor at server
//	fdT. Complain if there is no such message group at fdT.
//

extern "C" void VSS_StripZerosInPlace(char *); // in cliMsg.c

extern "C"
float AUDupdate(int fdT, char *szActor, int numFloats, float *floatArray)
{
	if (fdT < 0)
		{
		fprintf(stderr, "vss client error: invalid handle to .aud file.  Possible error in .aud file.\n");
		return hNil;
		}

	if (!SelectSoundServer(serverHandles[fdT])) return hNil;

	float h = symtabActor[fdT].HactorFromSz(szActor);
	if (h < 0.)
		{
		if (vfEnableWarnNoMG)
			{
			fprintf(stderr, "vss client error: No message group called '%s'.\n",  szActor);
			symtabActor[fdT].Dump();
			}
		return hNil;
		}

	char szT2[20];
	char szT[5000];
	sprintf(szT, "SendData %f [ ", h);
	for (int i=0; i<numFloats; i++)
		{
		sprintf(szT2, "%f ", floatArray[i]);
		strcat(szT, szT2);
		}
	strcat(szT, "]");
	VSS_StripZerosInPlace(szT);
	return actorMessageRetval(szT);
}

//===========================================================================
//		AUDupdateTwo
//
//	Call AUDupdate for two servers, convenient when using a pair
//	of servers for wet and dry localization.
//
extern "C"
void AUDupdateTwo(int vss1, int vss2, char *szActor, int size, float *array)
{
	if (SelectSoundServer(serverHandles[vss1]))
		(void)AUDupdate(vss1, szActor, size, array);
	if (SelectSoundServer(serverHandles[vss2]))
		(void)AUDupdate(vss2, szActor, size, array);
}

//===========================================================================
//		AUDupdateMany
//
//	Call AUDupdate for an array of server handles.
//
extern "C"
void AUDupdateMany(int numHandles, int * handleArray, char *actorHandleName,
				int numFloats, float *floatArray)
{
	int	fdT;

	for (int i = 0; i < numHandles; i++)
	{
		fdT = handleArray[i];

		if (SelectSoundServer(serverHandles[fdT]))
			(void)AUDupdate(fdT, actorHandleName, numFloats, floatArray);
	}

}

//===========================================================================
//		AUDqueue
//
//	Queue up an array of data to send to a message group with
//	ScheduleData whenever AUDflushQueue is finally called. Complain
//	if AUDqueue is called more than qdMax times before AUDflushQueue
//	is called.
//
extern "C"
void AUDqueue(int size, float * data, float when)
{
	if (QdataCount >= qdMax)
	{
		fprintf(stderr, "vss client error: too much data queued. Flushing needed.\n");
		return;
	}

	Qdata[QdataCount].time = when;
	Qdata[QdataCount].size = size;

// printf("\t\tqueueing %d at %f: ", size, when);
	Qdata[QdataCount].farray = (float *)malloc(size * sizeof(float));

	if (NULL == Qdata[QdataCount].farray)
	{
		fprintf(stderr, "vss client error: out of memory trying to queue data.\n");
		return;
	}

	for (int i=0; i<size; i++)
	{
		Qdata[QdataCount].farray[i] = data[i];
// printf("%f ", data[i]);
	}
// printf("\n\n");
	QdataCount++;
}

//===========================================================================
//		AUDflushQueue
//
//	Send queued data to the message group szActor at server fdT using
//	ScheduleData. Complain if there is no actor called szActor.
//
extern "C"
void AUDflushQueue(int fdT, char *szActor, int fPreserveQueueData)
{
	if (fdT < 0)
		{
		fprintf(stderr, "vss client error: invalid handle to .aud file.  Possible error in .aud file.\n");
		return;
		}
    if (!SelectSoundServer(serverHandles[fdT])) return;

    float h = symtabActor[fdT].HactorFromSz(szActor);
    if (h < 0.)
        {
		if (vfEnableWarnNoMG)
			{
        	fprintf(stderr, "vss client error: No message group called '%s'.\n",  szActor);
        	symtabActor[fdT].Dump();
			}
        return;
        }

// printf("AUDflushQueue flushing %d\n", QdataCount);
	//	set up the message
    char szT[5000];
	char szT2[50];
	int cqd;
	sprintf(szT, "ScheduleData %f [ ", h);

	//	first build the time offset array
	for (cqd = 0; cqd< QdataCount; cqd++)
	{
		sprintf(szT2, "%f ", Qdata[cqd].time);
		strcat(szT, szT2);
	}
	strcat(szT, "]");

	// add the data arrays
	for (cqd = 0; cqd< QdataCount; cqd++)
	{
		strcat(szT, " [");
		for(int cdata = 0; cdata < Qdata[cqd].size; cdata++)
		{
			sprintf(szT2, "%f ", Qdata[cqd].farray[cdata]);
			strcat(szT, szT2);
		}
		strcat(szT, "]");
	}
	// send it off to the server
// printf("AUDflushQueue sending %s\n\n", szT);
    actorMessage(szT);

	if (!fPreserveQueueData)
		QdataCount = 0;
}
#line 719 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 94 "parseMsg.y"
{ if (!fFiltered && *vszFilterCommand) { /*printf("ASDFASDFASDF <%s>\n", vszFilterCommand);;;;*/ fclose(yyin); yyin = fopen("/dev/null", "r"); vfAbsorbText = 1; } }
break;
case 5:
#line 99 "parseMsg.y"
{
			if (!vfAbsorbText && !symtabActor[fd].FAddSz(yyvsp[-3].string, createActor(yyvsp[0].string)))
				{
				fprintf(stderr, "vss client error: Command \"%s = Create %s\":\n", yyvsp[-3].string, yyvsp[0].string);
				yyerror("Actor name already used, or too many actors in this AUDinit() call.");
				}
		/*	else*/
		/*		{*/
		/*		printf("added a guy %s\n", $4);*/
		/*		symtabActor[fd].Dump();*/
		/*		}*/
		}
break;
case 6:
#line 111 "parseMsg.y"
{ *vszhnote = '\0'; }
break;
case 7:
#line 112 "parseMsg.y"
{ strcpy(vszhnote, yyvsp[-1].string); /*printf("bgnnote lvalue is \"%s\"\n", vszhnote);*/ }
break;
case 9:
#line 114 "parseMsg.y"
{
				float h = symtabActor[fd].HactorFromSz(yyvsp[0].string); /* grab it before we delete */
				if (!vfAbsorbText && (h < 0. || !symtabActor[fd].FDeleteSz(yyvsp[0].string)))
					{
					h = symtabNote[fd].HnoteFromSz(yyvsp[0].string);
					if (h < 0. || !symtabNote[fd].FDeleteSz(yyvsp[0].string))
						{
						fprintf(stderr, "vss client error: Delete: undefined actor \"%s\"\n", yyvsp[0].string);
						yyerror("");
						goto LDeleteFinished;
						}
					}
				{
				char szT[1000];
				sprintf(szT, "Delete %f", h);
				if (!vfAbsorbText)
					actorMessage(szT);
				}
			LDeleteFinished: ;
			}
break;
case 10:
#line 134 "parseMsg.y"
{
		if (!vfAbsorbText && symtabActor[fd].FFoundSz(yyvsp[0].string))
			{
			fprintf(stderr, "vss client error: Syntax error: actor %s\n", yyvsp[0].string);
			yyerror("");
			}
		else if (!vfAbsorbText && symtabNote[fd].FFoundSz(yyvsp[0].string))
			{
			fprintf(stderr, "vss client error: Syntax error: handler %s\n", yyvsp[0].string);
			yyerror("");
			}
		else
			{
			/*printf("starting a generic msg \"%s\"\n", $1);*/
			strcpy(theArgs, yyvsp[0].string);
			strcat(theArgs, " ");
			}
		}
break;
case 11:
#line 152 "parseMsg.y"
{
			if(numErrors < MAX_ERRORS)
				{
				if (!vfAbsorbText)
					actorMessage(theArgs);
				}
		}
break;
case 12:
#line 159 "parseMsg.y"
{
			float z = 0;
			if (!vfAbsorbText && 1 == sscanf(yyvsp[0].string, "%*s %f", &z) && z > 0. && z < 24*3600.)
				{
				usleep((long)(z * 1000000));
				}
			}
break;
case 13:
#line 166 "parseMsg.y"
{
			float z = 0;
			if (!vfAbsorbText && 1 == sscanf(yyvsp[0].string, "%*s %f", &z))
				{
				if (z > 0. && z <= 3600.)
					SetReplyTimeout(z);
				else
					fprintf(stderr, "VSS client error: ignoring bogus ClientSetTimeout value %g\n", z);
				}
			}
break;
case 14:
#line 176 "parseMsg.y"
{
			char* pch = strchr(yyvsp[0].string, '"') + 1;
			*strchr(pch, '"') = '\0'; /* erase closing double quote*/
			if (!vfAbsorbText)
				fprintf(stderr, "%s\n", pch);
			}
break;
case 15:
#line 187 "parseMsg.y"
{ yyval.actorMessage = yyvsp[0].actorMessage; vfPaused = 0; }
break;
case 16:
#line 189 "parseMsg.y"
{ yyval.actorMessage = yyvsp[0].actorMessage; vfPaused = 1; }
break;
case 17:
#line 192 "parseMsg.y"
{
				if(!vfAbsorbText && numErrors < MAX_ERRORS)
					{
					/* assumption: BeginNoteBody can't be nested. */
					vhActor = symtabActor[fd].HactorFromSz(yyvsp[0].string);
					if (vhActor < 0)
						vhActor = symtabNote[fd].HnoteFromSz(yyvsp[0].string);
					if (vhActor < 0)
						{
						fprintf(stderr, "vss client error: Actor \"%s\" not defined\n", yyvsp[0].string);
						yyerror("Undefined actor in .aud file");
						*vszhnote = '\0';
						vhNote = -1;
						}
				sprintf(theArgs, "%s %f ",
					vfPaused ? "BeginSoundPaused" : "BeginSound",
					/*doesn't work... $1==tBEGIN_NOTE_MESSAGE ? "BeginSound" : "BeginSoundPaused", */
					vhActor);
					}
				}
break;
case 18:
#line 212 "parseMsg.y"
{
				if(!vfAbsorbText && numErrors < MAX_ERRORS)
					{
					if (vszhnote[0])
						vhNote = actorMessageRetval(theArgs);
					else
						{
						vhNote = -1;
						actorMessage(theArgs);
						}

					/* add (hNote,vszhnote) to symbol table. if (!*vszhnote), overwrite prev "" value. */
					/*;; Don't really need to maintain vhActor-vhNote connection anymore,
					  i.e. don't store vhActor in symtabNote. */
					if (*vszhnote && !symtabNote[fd].FAddSz(vszhnote, vhActor, vhNote))
						fprintf(stderr, "VSS client error: BeginSound failed during AUDinit\n\t(duplicate handle name \"%s\" for BeginSound?).\n", vszhnote);
					/*printf("actor %s = %g gets note %s = %g\n",
						"$2", vhActor,
						vszhnote, vhNote);*/

					/* clear it, just in case */
					*vszhnote = '\0';
					vhNote = -1;
					}
				}
break;
case 22:
#line 243 "parseMsg.y"
{ AppendArg("Create "); }
break;
case 23:
#line 244 "parseMsg.y"
{ AppendArg("Delete "); }
break;
case 24:
#line 245 "parseMsg.y"
{ AppendArg("BeginSound "); }
break;
case 25:
#line 246 "parseMsg.y"
{ AppendArg("BeginSoundPaused "); }
break;
case 29:
#line 254 "parseMsg.y"
{ AppendArg("["); }
break;
case 30:
#line 256 "parseMsg.y"
{ AppendArg("]"); }
break;
case 31:
#line 257 "parseMsg.y"
{ if (!vfAbsorbText) fprintf(stderr, "VSS client warning: empty array.\n"); }
break;
case 32:
#line 261 "parseMsg.y"
{ /*;;needed?*/ strcpy(yyval.string, yyvsp[0].string); }
break;
case 33:
#line 264 "parseMsg.y"
{ AppendArg(yyvsp[0].string); AppendArg(" "); }
break;
case 34:
#line 268 "parseMsg.y"
{ AppendArg("*"); }
break;
case 35:
#line 272 "parseMsg.y"
{ AppendArg("$"); }
break;
case 40:
#line 282 "parseMsg.y"
{ AppendArg("@"); }
break;
case 41:
#line 286 "parseMsg.y"
{ AppendArg(" to "); }
break;
case 42:
#line 290 "parseMsg.y"
{ AppendArg("\""); }
break;
case 43:
#line 293 "parseMsg.y"
{
			/* Substitute handles for names, of actors and notes.  Otherwise pass the string through. */
			float h;
			if ((h = symtabActor[fd].HactorFromSz(yyvsp[0].string)) >= 0.)
				/* print actor's handle */
				AppendFloat(h);
			else if ((h = symtabNote[fd].HnoteFromSz(yyvsp[0].string)) >= 0.)
				/* print note's handle */
				AppendFloat(h);
			else
				AppendArg(yyvsp[0].string);
			AppendArg(" ");
			}
break;
case 45:
#line 309 "parseMsg.y"
{ /*;;needed?*/ strcpy(yyval.string, yyvsp[0].string); }
break;
case 46:
#line 310 "parseMsg.y"
{ /*;;needed?*/ strcpy(yyval.string, yyvsp[0].string); }
break;
case 47:
#line 311 "parseMsg.y"
{ /*;;needed?*/ strcpy(yyval.string, yyvsp[0].string); }
break;
case 48:
#line 312 "parseMsg.y"
{ AppendArg("*? "); }
break;
case 52:
#line 319 "parseMsg.y"
{ /* variable-length array */ }
break;
case 53:
#line 321 "parseMsg.y"
{ /* variable-length array, to "**" end of array */ }
break;
#line 1128 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
